#ifndef WALLABYLIB_H
#define WALLABYLIB_H

int wallabylib_call();

#define _WALLABYLIB_FUNC( idx ) wallabylib_func = idx
#define _WALLABYLIB_CALL( ... ) wallabylib_call( __VA_ARGS__ )

#define _WALLABYLIB( idx, ... ) wallabylib_func = idx; wallabylib_call( __VA_ARGS__ )

int wallabylib_func;

#define printf                  0
#define backup_rom_to_sd        1
#define restore_sd_to_rom       2
#define display_set_cursor      3
#define display_print           4
#define display_clear           5
#define display_set_inverse     6
#define get_touch_coordinate    7
#define get_button_code         8
#define display_print_hex_word  9
#define set_backlight           10
#define access_sd               11

#endif
